//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	m_inet1 = "localhost";
    m_inet2 = "1024";
    m_inet3 = "1024";
    m_ipx1  = "00000000";
    m_ipx2  = "ffffffffffff";
    m_ipx3  = "2fff";
    m_ipx4  = "2fff";
    m_netbs1 = "GAME1";
    m_nbLana = -2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BExitClick(TObject *Sender)
{
	closesocket(sock);
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
	CBProtocol->ItemIndex = 0;
	CBProtocolChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBProtocolChange(TObject *Sender)
{
	m_sent = false;
    m_hod = false;
	StatusBar1->Panels->Items[0]->Text = "";
   	WSAAsyncSelect(sock, Handle, 0, 0);
    closesocket(sock);
	WSACleanup();
	WSADATA WSAData;
    WSAStartup(0x0101, &WSAData);
	switch(CBProtocol->ItemIndex)
    {
     	case 0: //TCP
                m_af = AF_INET;
                m_type = SOCK_STREAM;
                m_protocol = IPPROTO_TCP;
                EAddr->MaxLength = 0;
                EPort->MaxLength = 0;
        		RadioGroup1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = false;
                Label5->Enabled = false;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_inet1;
                EPort->Text = m_inet2;
                EPort2->Text = "";
				RadioGroup1Click(NULL);
                break;
        case 1: //UDP
                m_af = AF_INET;
                m_type = SOCK_DGRAM;
                m_protocol = IPPROTO_UDP;
                EAddr->MaxLength = 0;
                EPort->MaxLength = 0;
        		RadioGroup1->Enabled = false;
                EAddr->Enabled = true;
                Label1->Enabled = true;
				EPort->Enabled = true;
                Label2->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                BListen->Enabled = true;
                BConnect->Enabled = false;
                BDisconnect->Enabled = false;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "()";
                EAddr->Text = m_inet1;
                EPort->Text = m_inet2;
                EPort2->Text = m_inet3;
                break;
        case 2: //SPX
                m_af = AF_IPX;
                m_type = SOCK_STREAM;//SOCK_SEQPACKET;
                m_protocol = NSPROTO_SPX;
                EAddr->MaxLength = 8;
                EPort->MaxLength = 12;
        		RadioGroup1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_ipx1;
                EPort->Text = m_ipx2;
                EPort2->Text = m_ipx3;
				RadioGroup1Click(NULL);
        		break;
        case 3: //IPX
                m_af = AF_IPX;
                m_type = SOCK_DGRAM;
                m_protocol = NSPROTO_IPX;
                EAddr->MaxLength = 8;
                EPort->MaxLength = 12;
        		RadioGroup1->Enabled = false;
                EAddr->Enabled = true;
                Label1->Enabled = true;
				EPort->Enabled = true;
                Label2->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                BConnect->Enabled = false;
                BDisconnect->Enabled = false;
                BListen->Enabled = true;
                ESock->Visible = true;
                Label6->Visible = true;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_ipx1;
                EPort->Text = m_ipx2;
                EPort2->Text = m_ipx3;
                ESock->Text = m_ipx4;
        		break;
        case 4: //SPXII
                m_af = AF_IPX;
                m_type = SOCK_STREAM;//SOCK_SEQPACKET;
                m_protocol = NSPROTO_SPXII;
                EAddr->MaxLength = 8;
                EPort->MaxLength = 12;
        		RadioGroup1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = true;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_ipx1;
                EPort->Text = m_ipx2;
                EPort2->Text = m_ipx3;
				RadioGroup1Click(NULL);
        		break;
        case 5: //NetBIOS  
                m_af = AF_NETBIOS;
                m_type = SOCK_SEQPACKET;
                m_protocol = m_nbLana;
                EAddr->MaxLength = 0;
                EPort->MaxLength = 0;
        		RadioGroup1->Enabled = true;
                EAddr->Enabled = true;
                Label1->Enabled = true;
                EPort->Enabled = true;
                EPort2->Enabled = true;
                Label5->Enabled = false;
                ESock->Visible = false;
                Label6->Visible = false;
                BListen->Caption = " ";
                Label1->Caption = "";
                Label2->Caption = "";
                Label5->Caption = "";
                EAddr->Text = m_netbs1;
                EPort->Text = IntToStr(m_nbLana);
                EPort2->Text = "";
        		break;
    }
}
//---------------------------------------------------------------------------
AnsiString TForm1::m_comp(AnsiString str1, AnsiString str2)
{
	int i,j;
    AnsiString result = AnsiString::StringOfChar('-',4);
	for(i=1; i<5; i++)
    {
		if(str1[i] == str2[i]) result[i] = '';
        else
        {
        	for(j=1; j<5; j++) if(str1[i] == str2[j]) break;
            if(j<5) result[i] = 'K';
        }
    }
    return result;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BSendClick(TObject *Sender)
{
	if(m_hod)
    {
		m_sent = true;
    	switch(CBProtocol->ItemIndex)
	    {
    	    case 0: //TCP
	        case 2: //SPX
	        case 4: //SPXII
            case 5: //NetBIOS
        	{
	        	send(sock, MEOtgad->Text.c_str(), 5, 0);
    	    }
        	break;
	        case 1: //UDP
    	    {
        		SOCKADDR_IN dest_sin;
            	if(!FillAddrIN(&dest_sin, TRUE))
	            {
    	        	closesocket(sock);
        	        break;
	            }
            	sendto(sock, MEOtgad->Text.c_str(), 5, 0, (PSOCKADDR)&dest_sin, sizeof(dest_sin));
        	}
    	    break;
        	case 3: //IPX
	        {
    	    	SOCKADDR_IPX dest_sipx;
				if(!FillAddrIPX(&dest_sipx, TRUE))
				{
	            	closesocket(sock);
    	            break;
        	    }
            	sendto(sock, MEOtgad->Text.c_str(), 5, 0, (PSOCKADDR)&dest_sipx, sizeof(dest_sipx));
	        }
    	    break;
	    }
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BConnectClick(TObject *Sender)
{
    if(m_af == AF_NETBIOS)
    {
        m_nbLana = StrToInt(EPort->Text);
        m_protocol = m_nbLana;
    }
	closesocket(sock);
	sock = socket(m_af, m_type, m_protocol);
    if(sock == INVALID_SOCKET)
    {
    	Application->MessageBox("socket() failed", "Error", MB_OK);
        return;
    }
    switch(m_af)
    {
     	case AF_INET:
    	{
			SOCKADDR_IN dest_sin;
	    	if(!FillAddrIN(&dest_sin, TRUE))
		    {
    			closesocket(sock);
        		return;
		    }
    		if(connect(sock, (PSOCKADDR)&dest_sin, sizeof(dest_sin)) < 0)
	    	{
    			closesocket(sock);
	        	Application->MessageBox("connect() failed", "Error", MB_OK);
		        return;
    		}
        }
        break;
        case AF_IPX:
        {
			SOCKADDR_IPX dest_sipx;
			if(!FillAddrIPX(&dest_sipx, TRUE))
			{
            	closesocket(sock);
                break;
            }
    		if(connect(sock, (PSOCKADDR)&dest_sipx, sizeof(dest_sipx)) < 0)
	    	{
    			closesocket(sock);
	        	Application->MessageBox("connect() failed", "Error", MB_OK);
		        return;
    		}
        }
        break;
        case AF_NETBIOS:
        {
        	SOCKADDR_NB dest_snb;
            SET_NETBIOS_SOCKADDR(&dest_snb, NETBIOS_UNIQUE_NAME /*NETBIOS_GROUP_NAME*/, EAddr->Text.c_str(), 0);
    		if(connect(sock, (PSOCKADDR)&dest_snb, sizeof(dest_snb)) < 0)
	    	{
    			closesocket(sock);
	        	Application->MessageBox("connect() failed", "Error", MB_OK);
		        return;
    		}
        }
        break;
    }
    StatusBar1->Panels->Items[0]->Text = " ";
    if(WSAAsyncSelect(sock, Handle, WSA_NETEVENT, FD_READ|FD_CLOSE) > 0)
    {
    	wsprintf(szBuff, "%d (0x%x)");
        Application->MessageBox("Error on WSAAsyncSelect()", szBuff, MB_OK);
        closesocket( sock );
    }
    StatusBar1->Panels->Items[0]->Text = StatusBar1->Panels->Items[0]->Text + ".  .";
    m_hod = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BDisconnectClick(TObject *Sender)
{
    CBProtocolChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BListenClick(TObject *Sender)
{
    if(m_af == AF_NETBIOS)
    {
        m_nbLana = StrToInt(EPort->Text);
        m_protocol = m_nbLana;
    }
	switch(m_type)
    {
    	case SOCK_STREAM:
        case SOCK_SEQPACKET:
        {
        	closesocket(sock);
			sock = socket(m_af, m_type, m_protocol);
		    if(sock == INVALID_SOCKET)
		    {
            	sprintf(szBuff, "%d is the error", WSAGetLastError());
                Application->MessageBox(szBuff, "socket() failed", MB_OK);
		        return;
		    }
			switch(m_af)
		    {
		    	case AF_INET:
		        {
					SOCKADDR_IN local_sin;
				    if(!FillAddrIN(&local_sin, FALSE))
				    {
				        closesocket(sock);
        				return;
				    }
				    StatusBar1->Panels->Items[0]->Text = " .. (Async)";
				    if(bind(sock, (struct sockaddr FAR *) &local_sin, sizeof(local_sin)) == SOCKET_ERROR)
				    {
				        sprintf(szBuff, "%d is the error", WSAGetLastError());
        				Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		        		closesocket(sock);
		        		return;
				    }
		        }
        		break;
		        case AF_IPX:
		        {
					SOCKADDR_IPX local_sipx;
                    if(!FillAddrIPX(&local_sipx, FALSE))
                    {
                    	closesocket(sock);
                        return;
                    }
				    StatusBar1->Panels->Items[0]->Text = " .. (Async)";
				    if(bind(sock, (struct sockaddr FAR *) &local_sipx, sizeof(local_sipx)) == SOCKET_ERROR)
				    {
				        sprintf(szBuff, "%d is the error", WSAGetLastError());
        				Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		        		closesocket(sock);
		        		return;
				    }
                    char outtext[128];
                    SOCKADDR_IPX addr;
                    int addrlen = sizeof(addr);
				    if(getsockname(sock,(PSOCKADDR)&addr,&addrlen) == SOCKET_ERROR)
				    {
				        ShowMessage("ERROR getsocketname()");
				    }
				    else
				    {
				        lstrcpy(outtext, "   ");
				        GetAddrString(&addr, outtext + lstrlen(outtext));
				    }
                    StatusBar1->Panels->Items[0]->Text = AnsiString(outtext);
        		}
		        break;
                case AF_NETBIOS:
                {
                	SOCKADDR_NB local_snb;
           			SET_NETBIOS_SOCKADDR(&local_snb, NETBIOS_UNIQUE_NAME/* NETBIOS_GROUP_NAME*/, EAddr->Text.c_str(), 0);
					if(bind(sock, (struct sockaddr FAR *) &local_snb, sizeof(local_snb)) == SOCKET_ERROR)
				    {
				        sprintf(szBuff, "%d is the error", WSAGetLastError());
        				Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		        		closesocket(sock);
		        		return;
				    }
                    StatusBar1->Panels->Items[0]->Text = "  ...";
                }
                break;
		    }
		    if(listen(sock, MAX_PENDING_CONNECTS) < 0)
		    {
        		sprintf(szBuff, "%d is the error", WSAGetLastError());
		        Application->MessageBox(szBuff, "listen(sock) failed", MB_OK);
		        return;
		    }
		    if(WSAAsyncSelect(sock, Handle, WSA_ACCEPT, FD_ACCEPT) > 0)
		    {
        		wsprintf( szBuff, "%d (0x%x)");
		        Application->MessageBox("Error on WSAAsyncSelect()", szBuff, MB_OK);
		        StatusBar1->Panels->Items[0]->Text = "Async listen cancelled";
		        closesocket( sock );
		    }
        }
        break;
     	case SOCK_DGRAM:
        {
			switch(m_af)
            {
             	case AF_INET:
                {
					m_inet1 = EAddr->Text;
                    m_inet2 = EPort->Text;
                    m_inet3 = EPort2->Text;
                }
                break;
                case AF_IPX:
                {
					m_ipx1 = EAddr->Text;
                    m_ipx2 = EPort->Text;
                    m_ipx3 = EPort2->Text;
                    m_ipx4 = ESock->Text;
                }
                break;
            }
			CBProtocolChange(NULL);
            closesocket(sock);
            sock = socket(m_af, m_type, m_protocol);
            if(sock == INVALID_SOCKET)
            {
            	Application->MessageBox("socket() failed", "Error", MB_OK);
                break;
            }
            switch(m_af)
            {
            	case AF_INET:
                {
		        	SOCKADDR_IN local_sin;
        		    local_sin.sin_family = AF_INET;
		            local_sin.sin_addr.s_addr = INADDR_ANY;
		            local_sin.sin_port = htons((u_short)StrToInt(EPort2->Text));
        		    if (bind(sock, (struct sockaddr FAR *)&local_sin, sizeof(local_sin)) == SOCKET_ERROR)
		            {
        		    	sprintf(szBuff, "%d is the error", WSAGetLastError());
                		Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		                closesocket(sock);
        		        break;
                    }
                    StatusBar1->Panels->Items[0]->Text = " ";
                }
                break;
                case AF_IPX:
                {
                	SOCKADDR_IPX local_sipx;
                    ZeroMemory(&local_sipx, sizeof(local_sipx));
                    local_sipx.sa_family = AF_IPX;
                    AtoH(ESock->Text.c_str(), (char *)&local_sipx.sa_socket, 2); 		// Network order
	      		    if (bind(sock, (struct sockaddr FAR *)&local_sipx, sizeof(local_sipx)) == SOCKET_ERROR)
		            {
        		    	sprintf(szBuff, "%d is the error", WSAGetLastError());
                		Application->MessageBox(szBuff, "bind(sock) failed", MB_OK);
		                closesocket(sock);
        		        break;
                    }
                    char outtext[128];
                    SOCKADDR_IPX addr;
                    int addrlen = sizeof(addr);
				    if(getsockname(sock,(PSOCKADDR)&addr,&addrlen) == SOCKET_ERROR)
				    {
				        ShowMessage("ERROR getsocketname()");
				    }
				    else
				    {
				        lstrcpy(outtext, "   ");
				        GetAddrString(&addr, outtext + lstrlen(outtext));
				    }
                    StatusBar1->Panels->Items[0]->Text = AnsiString(outtext);
                }
                break;
            }
            WSAAsyncSelect(sock, Handle, WSA_NETEVENT, FD_READ);
		    StatusBar1->Panels->Items[0]->Text = StatusBar1->Panels->Items[0]->Text + ".  .";
            m_hod = true;
        }
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
	switch(RadioGroup1->ItemIndex == 0)
    {
     	case 0:
        		BListen->Enabled = false;
				BConnect->Enabled = true;
                BDisconnect->Enabled = true;
                EAddr->Enabled = true;
                Label1->Enabled = true;
                if(m_protocol == NSPROTO_SPX)
                {
                 	EPort->Enabled = true;
                    Label2->Enabled = true;
                }
                break;
        case 1:
        		BListen->Enabled = true;
				BConnect->Enabled = false;
                BDisconnect->Enabled = false;
                EAddr->Enabled = false;
                Label1->Enabled = false;
                if(m_protocol == NSPROTO_SPX)
                {
                 	EPort->Enabled = false;
                    Label2->Enabled = false;
                }
                break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	int status;
	WSADATA WSAData;
    char szTemp[80];
    if ((status = WSAStartup(0x0101, &WSAData)) == 0)
    {
    	Caption = AnsiString(WSAData.szDescription) + " " + AnsiString(WSAData.szSystemStatus);
    }
    else
    {
    	sprintf(szTemp, "%d is the err", status);
        Application->MessageBox(szTemp, "Error", MB_OK);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	WSACleanup();
}
//---------------------------------------------------------------------------
bool TForm1::FillAddrIN(PSOCKADDR_IN psin, bool bClient)
{
   	DWORD dwSize;
	PHOSTENT phe;
   	char szTemp[200];
    ZeroMemory(psin, sizeof(SOCKADDR_IN));
   	psin->sin_family = AF_INET;
   	if (bClient)
   	{
    	if(isalpha(EAddr->Text[1]))
        {
	      	phe = gethostbyname(EAddr->Text.c_str());
    	  	if (phe == NULL)
        	{
         		sprintf(szTemp, "%d is the error. Make sure '%s' is listed in the hosts file.", WSAGetLastError(), szBuff);
	        	Application->MessageBox(szTemp, "gethostbyname() failed.", MB_OK);
    	    	return FALSE;
      		}
	      	memcpy((char FAR *)&(psin->sin_addr), phe->h_addr, phe->h_length);
        }
        else
        {
        	psin->sin_addr.s_addr = inet_addr(EAddr->Text.c_str());
        }
   	}
    else
    { // server
      	dwSize = sizeof(szBuff);
      	gethostname(szBuff, dwSize);
      	psin->sin_addr.s_addr = INADDR_ANY;
    }
    psin->sin_port = htons((u_short)StrToInt(EPort->Text));
   	return true;
}
//---------------------------------------------------------------------------
bool TForm1::FillAddrIPX(PSOCKADDR_IPX psipx, bool bClient)
{
    ZeroMemory(psipx, sizeof(SOCKADDR_IPX));
	psipx->sa_family = AF_IPX;
    if(bClient)
    {
    	AtoH(EAddr->Text.c_str(), (char *)&psipx->sa_netnum, 4);        // Network order
        AtoH(EPort->Text.c_str(), (char *)&psipx->sa_nodenum, 6);  		// Network order
        AtoH(EPort2->Text.c_str(), (char *)&psipx->sa_socket, 2); 		// Network order
    }
    else
    {
		AtoH(EPort2->Text.c_str(), (char *)&psipx->sa_socket, 2); 		// Network order
    }
   	return true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnWSAaccept(TMessage &Message)
{
 	int rc, addr_len;
 	SOCKADDR addr;
 	if(WSAGETSELECTERROR(Message.LParam) != 0)
    {
		ShowMessage(" ");
		WSAAsyncSelect((SOCKET)Message.WParam, Handle, 0, 0);
		return;
 	} // if
 	addr_len = sizeof(addr);
    if(m_af == AF_NETBIOS) addr_len = sizeof(SOCKADDR_NB);
 	sock = accept((SOCKET)Message.WParam, (LPSOCKADDR)&addr, (int *)&addr_len);
 	if(sock == INVALID_SOCKET)
    {
		ShowMessage(" ");
		WSAAsyncSelect((SOCKET)Message.WParam, Handle, 0, 0);
		return;
 	} // if
 	rc = WSAAsyncSelect(sock, Handle, WSA_NETEVENT, FD_READ|FD_CLOSE);
 	if (rc > 0)
    {
		ShowMessage(" WSAAsyncSelect");
		WSAAsyncSelect((SOCKET)Message.WParam, Handle, 0, 0);
		return;
 	} // if
 	StatusBar1->Panels->Items[0]->Text = " ";
    StatusBar1->Panels->Items[0]->Text = StatusBar1->Panels->Items[0]->Text + ".    .";
    m_hod = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnWSAnetevent(TMessage &Message)
{
 	char buf[5];
	switch(WSAGETSELECTEVENT(Message.LParam))
    {
     	case FD_READ:
        {
			switch(m_type)
            {
            	case SOCK_STREAM:
                case SOCK_SEQPACKET:
                {
					recv((SOCKET)Message.WParam, buf, 5, 0);
					if(m_sent)
		            {
        		    	EOtvet->Text = AnsiString(buf);
                		m_sent = false;
				        if(EOtvet->Text == "") ShowMessage(" !!!");
                        m_hod = false;
		            }
        		    else
		            {
        		    	AnsiString TmpStr(buf);
                		TmpStr = m_comp(TmpStr,MEZagad->Text);
		                send((SOCKET)Message.WParam, TmpStr.c_str(), 5, 0);
                        if(TmpStr == "") ShowMessage(" !");
                        m_hod = true;
        		    }
                }
                break;
                case SOCK_DGRAM:
                {
                	switch(m_af)
                    {
                     	case AF_INET:
                        {
							SOCKADDR_IN dest_sin;
					    	if(!FillAddrIN(&dest_sin, TRUE))
						    {
    							closesocket(sock);
				        		break;
		    				}
                            int addr_length = sizeof(dest_sin);
                            recvfrom((SOCKET)Message.WParam, buf, 5, 0, (PSOCKADDR)&dest_sin, &addr_length);
							if(m_sent)
				            {
        				    	EOtvet->Text = AnsiString(buf);
                				m_sent = false;
						        if(EOtvet->Text == "") ShowMessage(" !!!");
                                m_hod = false;
				            }
        				    else
		        		    {
        		    			AnsiString TmpStr(buf);
		                		TmpStr = m_comp(TmpStr,MEZagad->Text);
				                sendto((SOCKET)Message.WParam, TmpStr.c_str(), 5, 0, (PSOCKADDR)&dest_sin, addr_length);
                                if(TmpStr == "") ShowMessage(" !");
                                m_hod = true;
        				    }
                    	}
                    	break;
                        case AF_IPX:
                        {
							SOCKADDR_IPX dest_sipx;
                            ZeroMemory(&dest_sipx, sizeof(dest_sipx));
				            dest_sipx.sa_family = AF_IPX;
						    AtoH(EAddr->Text.c_str(), (char *)&dest_sipx.sa_netnum, 4);        	// Network order
						    AtoH(EPort->Text.c_str(), (char *)&dest_sipx.sa_nodenum, 6);  		// Network order
						    AtoH(EPort2->Text.c_str(), (char *)&dest_sipx.sa_socket, 2); 		// Network order
                            int addr_length = sizeof(dest_sipx);
                            recvfrom((SOCKET)Message.WParam, buf, 5, 0, (PSOCKADDR)&dest_sipx, &addr_length);
							if(m_sent)
				            {
        				    	EOtvet->Text = AnsiString(buf);
                				m_sent = false;
						        if(EOtvet->Text == "") ShowMessage(" !!!");
                                m_hod = false;
				            }
        				    else
		        		    {
        		    			AnsiString TmpStr(buf);
		                		TmpStr = m_comp(TmpStr,MEZagad->Text);
				                sendto((SOCKET)Message.WParam, TmpStr.c_str(), 5, 0, (PSOCKADDR)&dest_sipx, addr_length);
                                if(TmpStr == "") ShowMessage(" !");
                                m_hod = true;
        				    }
                        }
                        break;
                    }
                }
                break;
            }
            if(m_hod) StatusBar1->Panels->Items[0]->Text = " .";
            else StatusBar1->Panels->Items[0]->Text = "   .";
        }
        break;
        case FD_CLOSE:
        {
         	StatusBar1->Panels->Items[0]->Text = " ";
        }
        break;
    }
}
//---------------------------------------------------------------------------
void TForm1::AtoH(char * src, char * dest, int destlen)
{
	while(destlen--)
    {
		*dest++ = (char)((BtoH(*src++) << 4) + BtoH(*src++));
    }
}
//---------------------------------------------------------------------------
unsigned char TForm1::BtoH(char ch)
{
    if (ch >= '0' && ch <= '9') return (unsigned char)(ch - '0');        // Handle numerals
    if (ch >= 'A' && ch <= 'F') return (unsigned char)(ch - 'A' + 0xA);  // Handle capitol hex digits
    if (ch >= 'a' && ch <= 'f') return (unsigned char)(ch - 'a' + 0xA);  // Handle small hex digits
    return(255);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EOtvetChange(TObject *Sender)
{
	if(EOtvet->Text[1] == '') Image1->Picture->LoadFromFile("BITMAP1.BMP");
    else if(EOtvet->Text[1] == 'K') Image1->Picture->LoadFromFile("BITMAP2.BMP");
    else Image1->Picture = NULL;
	if(EOtvet->Text[2] == '') Image2->Picture->LoadFromFile("BITMAP1.BMP");
    else if(EOtvet->Text[2] == 'K') Image2->Picture->LoadFromFile("BITMAP2.BMP");
    else Image2->Picture = NULL;
	if(EOtvet->Text[3] == '') Image3->Picture->LoadFromFile("BITMAP1.BMP");
    else if(EOtvet->Text[3] == 'K') Image3->Picture->LoadFromFile("BITMAP2.BMP");
    else Image3->Picture = NULL;
	if(EOtvet->Text[4] == '') Image4->Picture->LoadFromFile("BITMAP1.BMP");
    else if(EOtvet->Text[4] == 'K') Image4->Picture->LoadFromFile("BITMAP2.BMP");
    else Image4->Picture = NULL;
}
//---------------------------------------------------------------------------
void TForm1::HtoA(char * src, char * dest, int srclen)
{
    char * destptr; 									// temp pointers
    UCHAR * srcptr;
    srcptr = (UCHAR *)src;
    destptr = dest;
    while(srclen--)
    {
    	*destptr++ = HtoB((UCHAR)(*srcptr >> 4));      	// Convert high order nibble
    	*destptr++ = HtoB((UCHAR)(*srcptr++ & 0x0F));  	// Convert low order nibble
    }
    *destptr = 0;  										// Null terminator
}
//---------------------------------------------------------------------------
char TForm1::HtoB(UCHAR ch)
{
    if (ch <= 9) return (char)('0' + ch);        	// handle decimal values
    if (ch <= 0xf) return (char)('A' + ch - 10); 	// handle hexidecimal specific values
    return('X');                                 	// Someone screwed up
}
//---------------------------------------------------------------------------
void TForm1::GetAddrString(PSOCKADDR_IPX pSAddr, char * dest)
{
    char abuf[15];                              	// temp buffer
    char * currptr;                             	// temp destination pointer
    currptr = dest; 								// initialize destination pointer
    HtoA((char *)&pSAddr->sa_netnum, abuf, 4);  	// convert network number
    lstrcpy(currptr, abuf);
    currptr += 8;
    lstrcat(currptr, ".");                      	// don't forget seperator
    currptr++;
    HtoA((char *)&pSAddr->sa_nodenum, abuf, 6); 	// convert node number
    lstrcat(currptr, abuf);
    currptr += 12;
    lstrcat(currptr, ".");                      	// seperator
    currptr++;
    HtoA((char *)&pSAddr->sa_socket, abuf, 2);  	// convert socket number
    lstrcat(currptr, abuf);
}
//---------------------------------------------------------------------------



