//---------------------------------------------------------------------------
#ifndef MainFrmH
#define MainFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Mask.hpp>
#include <NMUDP.hpp>
#include <ScktComp.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <winsock.h>
#include <wsipx.h>
#include <wsnetbs.h>
#include <stdio.h>
//---------------------------------------------------------------------------
#define WSA_ACCEPT   (WM_APP + 0)
#define WSA_NETEVENT (WM_APP + 1)
#define MAX_PENDING_CONNECTS 4  /* The backlog allowed for listen() */
#define NO_FLAGS_SET         0  /* Used with recv()/send()          */
#define MY_MSG_LENGTH       80  /* msg buffer sent back and forth   */

class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TRadioGroup *RadioGroup1;
	TGroupBox *GroupBox1;
	TEdit *EAddr;
	TLabel *Label1;
	TLabel *Label2;
	TEdit *EPort;
	TGroupBox *GroupBox2;
	TComboBox *CBProtocol;
	TGroupBox *GroupBox3;
	TGroupBox *GroupBox4;
	TLabel *Label3;
	TMaskEdit *MEZagad;
	TMaskEdit *MEOtgad;
	TButton *BSend;
	TLabel *Label4;
	TEdit *EOtvet;
	TButton *BExit;
	TButton *BConnect;
	TButton *BDisconnect;
	TStatusBar *StatusBar1;
	TLabel *Label5;
	TEdit *EPort2;
	TButton *BListen;
	TPanel *Panel1;
	TImage *Image1;
	TImage *Image2;
	TImage *Image3;
	TImage *Image4;
	TEdit *ESock;
	TLabel *Label6;
	void __fastcall BExitClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall CBProtocolChange(TObject *Sender);
	void __fastcall BSendClick(TObject *Sender);
	void __fastcall BConnectClick(TObject *Sender);
	void __fastcall BDisconnectClick(TObject *Sender);
	void __fastcall BListenClick(TObject *Sender);
	void __fastcall RadioGroup1Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall EOtvetChange(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
	bool FillAddrIN(PSOCKADDR_IN psin, bool bClient);
	bool FillAddrIPX(PSOCKADDR_IPX psipx, bool bClient);
    AnsiString m_comp(AnsiString str1, AnsiString str2);
    AnsiString m_str;
    bool m_sent;
    bool m_hod;
	SOCKET sock;
	char szBuff[80];
    void __fastcall OnWSAaccept(TMessage &Message);
    void __fastcall OnWSAnetevent(TMessage &Message);
	void AtoH(char * src, char * dest, int destlen);
	unsigned char BtoH(char ch);
	void HtoA(char * src, char * dest, int srclen);
	char HtoB(UCHAR ch);
	void GetAddrString(PSOCKADDR_IPX pSAddr, char * dest);
    int m_af;
    int m_type;
    int m_protocol;
    AnsiString m_inet1;
    AnsiString m_inet2;
    AnsiString m_inet3;
    AnsiString m_ipx1;
    AnsiString m_ipx2;
    AnsiString m_ipx3;
    AnsiString m_ipx4;
    AnsiString m_netbs1;
    int m_nbLana;
protected:
    BEGIN_MESSAGE_MAP
        VCL_MESSAGE_HANDLER(WSA_ACCEPT, TMessage, OnWSAaccept)
        VCL_MESSAGE_HANDLER(WSA_NETEVENT, TMessage, OnWSAnetevent)
    END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
